#include "LogMessage.h"

#include <stdio.h>
#include <stdarg.h>
#include <iostream>
#include <string>

using namespace ambenv;

LogMessage::LogMessage() : m_buffer( lm_maxbuffer ),
		   m_out( &std::cout ), m_err( &std::cerr ),
		   m_warn( &std::cerr ), m_info( &std::cout )
{
}

/*
LogMessage::LogMessage( const FILE * out, const FILE * err, const FILE * warn )
: m_buffer( lm_maxbuffer )
{
}
*/

void LogMessage::lm_printf( char * fmt, ... )
{
  va_list marker;
  va_start( marker, fmt );     
  vsprintf( &m_buffer[0], fmt, marker );
  va_end( marker );

  *(m_buffer.end()) = '\0';

  *m_out << &m_buffer[0];
}

void LogMessage::lm_fprintf( lm_stream streamId, char * fmt, ... )
{
  va_list marker;
  va_start( marker, fmt );
  vsprintf( &m_buffer[0], fmt, marker );
  va_end( marker );

  *(m_buffer.end()) = '\0';

  switch( streamId ) {
  case( lm_out ):
    *m_out << &m_buffer[0];
    break;
  case( lm_err ):
    *m_err << &m_buffer[0];
    break;
  case( lm_warn ):
    *m_warn << &m_buffer[0];
    break;
  case( lm_info ):
    *m_info << &m_buffer[0];
    break;
  }
}

void LogMessage::setInfo( std::ostream & ostream )
{
  m_info = &ostream;
}

void LogMessage::setWarn( std::ostream & ostream )
{
  m_warn = &ostream;
}
