#ifndef __OBJECT_H_
#define __OBJECT_H_

#include "Nameable.h"
#include "Ray.h"
#include "Vec3.h"

#include <vector>
#include <string>

namespace ambenv {

  class Object : public Nameable {
  public:
    Object();
    Object( const std::string & name );

    virtual ~Object();
    
    //! return true if the ray intersects this object
    /*! if this returns true, the other variables will hold the return values
     *  if this returns false, the other variable will be unchanged
     */
    virtual bool intersect( const Ray & ray, Real epsilon = 0.0 ) const;

  };

}; /* namespace ambenv */

#endif /* __OBJECT_H_ */
